/*---------------------------------------------------------------//
 RAWR - Preview Box

 (c) 2007-2008, RAWR Designs, Some Rights Reserved -
	Christopher "That Stevens Guy" Stevens
	Richard "Giant Eagle" Tuininga
 (cc) http://creativecommons.org/licenses/by-nc-sa/3.0/

 Any queries? -
	Email: contact[at]rawr-designs.com
	Forum: http://www.rejetto.com/forum/index.php?board=34.0
 	Homepage: http://rawr-designs.com
//---------------------------------------------------------------*/

//--Pre-set some variables.----------------------//
var disable	= false;
var boxOpen	= null;
var ext;
//--The main initialiser.------------------------//
function initPreviewBox(target,content,width,height) {
	ext = content.substring(content.lastIndexOf("."),content.length);
	ext = ext.toLowerCase();
	if(disable==false) {
		disable=true;
		setTimeout("disable=false;",350);
		if(target!=boxOpen) {
			if(boxOpen!=null) boxFade(boxOpen, "out");
			if(ext.match(".jpg|.jpeg|.png|.bmp|.tif|.tiff")) spawnImageBox(target,content);
			else if(ext==".mp3"||ext==".flv") spawnFlashBox(target,content,width);
			else if(ext==".swf") spawnSWFBox(target,content);
		} else {
			boxFade(boxOpen,"out");
		}
	}
}

//--Spawn a 'Loading' box.-----------------------//
function spawnBox(target,width,height) {
	gEBI(target).innerHTML = "<div class='Box' style='width:"+(width+10)+"px;filter:alpha(opacity=0);opacity:0;' id=\""+target+"Box\"><div style=\"width:"+(width+2)+"px;\" class=daBox1><span class=ModuleTitle id=\""+target+"Name\"><i>Loading...</i></span><a href=\"javascript:void(0);\" onClick=\"boxFade('"+target+"', 'out');\" style=\"cursor:normal;float:right;\"><div class=clo></div></a><div class=mov style=\"cursor:move;float:right;margin-right:5px;\"></div></div><div style=\"width:"+width+"px; height:"+height+"px;\" class=daBox2 id=\""+target+"Content\"><img src=\"/template/images/spacer.gif\" style=\"visibility:hidden;width:0px;height:20px;\"/><br /><img src=\"/template/images/loading.gif\" /></div><div style=\"width:"+(width+10)+"px;\" class=daBox3>&nbsp;</div></div>";
	Box = gEBI(target+"Box");
	Box.style.left = Box.offsetLeft-530+(480-Box.offsetWidth)+"px";
	Box.style.top = Box.offsetTop-(Box.offsetHeight+18)/2+"px";
	boxFade(target,"in");
	document.onmousedown = startDrag;
}

//--Spawn an SWF box.----------------------------//
function spawnSWFBox(target,content,name) {
	spawnBox(target,413,300);
	setTimeout("setSWFBox(\""+target+"\",\""+content+"\",\""+name+"\");",300);
}
function setSWFBox(target,content,name) {
	setName(name=="undefined"?content:name);
	content = "<object width=413 height=300 type='application/x-shockwave-flash' data=\""+content+"\"><param name=movie value=\""+content+"\"/></object>";
	gEBI(target+"Content").innerHTML = content
}

//--Spawn RAWR box.----------------------------//
var volume = 50;
var height, width, aspect;
var playmethod = "single";
function spawnFlashBox(target,content,name) {
	height = ext==".flv"?270:50;
	width = ext==".flv"&&aspect=="wide"?480:320;
	spawnBox(target,width,height);
	setTimeout("setFlashBox(\""+target+"\",\""+content+"\",\""+name+"\");",300);
}
function setFlashBox(target,content,name) {
	setName(name=="undefined"?content:name);
	content = content.replace('+','%2B').replace('&','%26');
	volume = getCookie('Volume') ? getCookie('Volume') : volume;
	playmethod = getCookie('Method') ? getCookie('Method')+"&mode=full" : "single&mode=full";
	if(autoplay == true) playmethod = "single";
	content = "<embed allowscriptaccess=always src='/template/flash/RAWR-Player.swf' width="+width+" height="+height+" type='application/x-shockwave-flash' flashvars=\"colorset=terayon&volume="+volume+"&playmethod="+playmethod+"&autostart=true&file="+content+"\"/>";
	gEBI(target+"Content").innerHTML = content;
	autoplay = false;
}

//--Spawn an Image box.--------------------------//
function spawnImageBox(target,content) {
	image = new Image();
	image.src= infoFolder+"previews_and_thumbnails/prev-"+content+".jpg";
	if(image.complete) {
		spawnBox(target,image.width,image.height);
		setImageBox(target,content,"setImmediatly");
	} else {
		setTimeout("setImageBox(\""+target+"\",\""+content+"\",\"none\");",10);
	}
}
function setImageBox(target,content,status) {
	if(image.width!=0) {
		if(status == "none") {
			spawnBox(target,image.width,image.height);
			status = "boxLoaded";
		}
		if(status == "boxLoaded") {
			setTimeout("setImageBox(\""+target+"\",\""+content+"\",\"setImage\");",325);
		} else if(status == "setImage") {
			if(image.complete) {
				gEBI(target+"Content").innerHTML = "<img src=\""+image.src+"\" alt=\"\" style=\"filter:alpha(opacity=0);opacity:0\" id=\""+target+"ImageBox\">";
				boxFade(target,"image");
				gEBI(target+"Name").innerHTML = unescape(content);
				image = null;
			} else {
				setTimeout("setImageBox(\""+target+"\",\""+content+"\",\"setImage\");",200);
			}
		} else if(status == "setImmediatly") {
			gEBI(target+"Content").innerHTML = "<img src=\""+image.src+"\" alt=\"\">";
			setName(content);
			image = null;
		}
	} else {
		setTimeout("setImageBox(\""+target+"\",\""+content+"\",\"none\");",50);
	}
}

//--Crops the name if necessary.-----------------//
function setName(file) {
	name = decodeURI(file.substring(file.lastIndexOf("/")+1,file.lastIndexOf(".")));
	gEBI(boxOpen+"Name","inn",name+ext);
	while (gEBI(boxOpen+"Box").offsetWidth-50 < gEBI(boxOpen+"Name").offsetWidth ||gEBI(boxOpen+"Name").offsetHeight >31) {
		name = name.substring(0,name.length-4)+".. ";
		gEBI(boxOpen+"Name","inn",name+ext);
	}
}

//--The fade function.---------------------------//
function boxFade(target,method,alpha) {
	method=="image"?id=gEBI(target+"ImageBox"):id=gEBI(target+"Box");
	if(!alpha) {
		if(method=="in"||method=="image") {
			if(method=="in") boxOpen = target;
			for(Y=24;Y>0;Y--) setTimeout("boxFade(\""+target+"\",\""+method+"\",\""+Y*4+"\");",Y*12);
			setTimeout("gEBI(\""+id.id+"\").style.opacity = 0.99;",300);
			setTimeout("gEBI(\""+id.id+"\").style.filter = 'alpha(opacity=100)';",300);
		} else if(method == "out") {
			if(gEBI(target+"Content").innerHTML.substr(1,3)!='img')	gEBI(target+"Content").innerHTML='';
			id.name = "fadingOut";
			if(boxOpen == target) boxOpen = null;
			for(Q=24;Q>0;Q--) setTimeout("boxFade(\""+target+"\",\"out\","+(100+(Q*-4))+");", Q*12);
			setTimeout("gEBI(\""+target+"\").innerHTML = '';",300);
		}
	} else {
		try {
			if(((method=="in"||method=="image")&&id.name!="fadingOut")||method=="out") {	
				id.style.filter	="alpha(opacity="+alpha+")";
				id.style.opacity =(alpha/100);
			}
		} catch(e) {}
	}
}

//--The drag function.---------------------------//
var sObj=null;
var drgOK=false;
var dX=dY=pX=pY=0;
function drag(e) {
	if(e==null)e=window.event;
	if(e.button<=1&&drgOK) {
		sObj.style.left=e.clientX-dX+(document.documentElement.scrollLeft-pX)+'px';
		sObj.style.top=e.clientY-dY+(document.documentElement.scrollTop-pY)+'px';
		return false;
	}
}
function endDrag(e) {
	gEBI(boxOpen).style.cursor = 'default';
	document.onmousemove = document.onmouseup = null;
	drgOK = false;
}
function startDrag(e) {
	if(e==null)e=window.event;
	var t=e.target!=null?e.target:e.srcElement;
	try {
		if(t.parentNode.className=="Box"||t.parentNode.parentNode.className=="Box"||t.parentNode.parentNode.parentNode.className=="Box") {
			sObj =t.parentNode.parentNode.parentNode.className=="Box"?t.parentNode.parentNode.parentNode:t.parentNode.parentNode.className=="Box"?t.parentNode.parentNode:t.parentNode;
			drgOK=true;
			dX =e.clientX-parseInt(sObj.style.left);
			dY =e.clientY-parseInt(sObj.style.top);
			pX = document.documentElement.scrollLeft;
			pY = document.documentElement.scrollTop;
			gEBI(boxOpen).style.cursor = 'move';
			document.onmousemove = drag;
			document.onmouseup = endDrag;
			return false;
		}
	} catch(e) {}
}

//--RAWR-Player flash interface.-----------------//
function playerVolume(volume) {
	setCookie('Volume',volume,exp);
}
function playbackMethod(playmethod) {
	setCookie('Method',playmethod,exp);
}